#ifdef WIN32
#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#endif

#include <GL/gl.h>	
#include <GL/glu.h>	
#include <stdlib.h>
#include <SDL.h>

void DrawGLScene()
{
	glClear(GL_COLOR_BUFFER_BIT);
	GLfloat triangle[3][2]={
		{ -1.0f, -1.0f},
		{ 1.0f, -1.0f},
		{ 0.0f, 1.0f},
		};

	GLfloat p[2]={0.0, 0.0f};
	int i, j;

  glClear (GL_COLOR_BUFFER_BIT);
	
	glBegin(GL_POINTS);
		
	for(j=0;j<20000;j++)
	{
		i=rand()%3;
		glVertex2f(p[0],p[1]);
		p[0]=(p[0]+triangle[i][0])/2.0f;
		p[1]=(p[1]+triangle[i][1])/2.0f;
	}
	glEnd();
	
	glFlush();
  SDL_GL_SwapBuffers();
}

void myReshapeFunc(GLsizei w, GLsizei h)
{
	glMatrixMode (GL_PROJECTION);   
	glLoadIdentity ();
	float ratio=(float)h/(float)w;
	glOrtho(-1,1,-ratio,ratio,-1,1);
	glViewport (0, 0, (GLsizei) w, (GLsizei) h); 
	glMatrixMode (GL_MODELVIEW);    /*  back to modelview matrix    */
}


int main(int argc, char **argv) 
{  
  /* Initialize SDL for video output */
  if ( SDL_Init(SDL_INIT_VIDEO) < 0 ) {
    fprintf(stderr, "Unable to initialize SDL: %s\n", SDL_GetError());
    exit(1);
  }

  /* Create a 640x480 OpenGL screen */
  if ( SDL_SetVideoMode(640, 480, 0, SDL_OPENGL |SDL_RESIZABLE) == NULL ) {
    fprintf(stderr, "Unable to create OpenGL screen: %s\n", SDL_GetError());
    SDL_Quit();
    exit(2);
  }

	/* Loop, drawing and checking events */
  //InitGL(640, 480);
  int done = 0;
  while ( ! done ) 
	{
    DrawGLScene();
    SDL_Event event;
	  SDL_WaitEvent(&event);
		
		switch(event.type)
		{  
			case SDL_QUIT					: done = 1;  
															break ;
			case SDL_KEYDOWN			: if ( event.key.keysym.sym == SDLK_ESCAPE ) 
														        done = 1;
															break;
			case SDL_VIDEORESIZE	: myReshapeFunc(event.resize.w,event.resize.h); 
															break;
    }    
  }
  SDL_Quit();
  return 1;
}
